/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"

static char crashSite[13][32];
static char roswel_title[32];
static char roswel_info[32];
static char roswel_location[32];
static char roswel_type[32];
static char roswel_terrain[32];
static void InitRoswellStrings()
{
	INI_READ_STRING("Roswell","Jungle","Jungle",crashSite[0],31);
	INI_READ_STRING("Roswell","Farm"  ,"Farm" ,crashSite[1],31);
	INI_READ_STRING("Roswell","Farm"  ,"Farm" ,crashSite[2],31);
	INI_READ_STRING("Roswell","Farm"  ,"Farm" ,crashSite[3],31);
	INI_READ_STRING("Roswell","Farm"  ,"Farm" ,crashSite[4],31);
	INI_READ_STRING("Roswell","Mountain","Mountain",crashSite[5],31);
	INI_READ_STRING("Roswell","Jungle","Jungle",crashSite[6],31);
	INI_READ_STRING("Roswell","Desert","Desert",crashSite[7],31);
	INI_READ_STRING("Roswell","Desert","Desert",crashSite[8],31);
	INI_READ_STRING("Roswell","Polar","Polar",crashSite[9],31);
	INI_READ_STRING("Roswell","Jungle","Jungle",crashSite[10],31);
	INI_READ_STRING("Roswell","Jungle","Jungle",crashSite[11],31);
	INI_READ_STRING("Roswell","Polar","Polar",crashSite[12],31);

	INI_READ_STRING("Roswell","Location","LOCATION",roswel_location,31);
	INI_READ_STRING("Roswell","Type","TYPE",roswel_type,31);
	INI_READ_STRING("Roswell","Terrain","TERRAIN",roswel_terrain,31);

	INI_READ_STRING("Roswell","Title","UFO Incident",roswel_title,31);
	INI_READ_STRING("Roswell","Info","Crash reported",roswel_info,31);
}
static int ShowCrashInfo(const char *ship, const char *location, const char *terrain)
{
	//UFO background
	LoadGeographBackScreen(15);
	LoadGeodataBackPalette(8);

	//Draw box
	((void (*)(int,int,int,int,int,int,int,int,int,int))(0x43D8C0))(0x5a,0x70,0x14,0x20,0x30,0x18,0x78,0xD0,0x14,0x86);

	DrawString(roswel_title,0x86,0x38,0x30,0);
	DrawString(roswel_info,0x86,0x48,0x30,1);

	DrawString(roswel_location,0x86,0x52,0x30,1);
	DrawDottedLine(0x86,0x82,1);
	DrawString(location,0x8B,0x52,0x82,1);

	DrawString(roswel_type,0x86,0x5a,0x30,1);
	DrawDottedLine(0x86,0x82,1);
	DrawString(ship,0x8B,0x5a,0x82,1);

	DrawString(roswel_terrain,0x86,0x62,0x30,1);
	DrawDottedLine(0x86,0x82,1);
	DrawString(terrain,0x8B,0x62,0x82,1);

	*ui_numButtons=0;

	//"Centre + 5sec" button
	CreateButton(0x80,0x30,0x0C,0xA0,0x86,StringTable_geoscape[48]);

	//Cancel
	CreateButton(0x90,0x30,0x0C,0xA0,0x86,StringTable_geoscape[49]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	int button;
	while(!(button=CheckForClickedButton()));
	return button;
}

static void UpdateMovingCrafts()
{
/*
EXPORT_ONCE unsigned char **locationList=(char **)0x49AAB0;
EXPORT_ONCE unsigned char **craftList=(char **)0x49AB18;
*/
	unsigned char *pLocation=*locationList;

	for(int i=0;i<50;i++)
	{
		unsigned char type=pLocation[0];
		if(type==1) //alien ship
		{
			if(GetRandom_0_n(0xFFFF)==0x7337)
			{
				unsigned char craftIdx=pLocation[1];
				unsigned char *pCraft=(*craftList)+craftIdx*104;
				unsigned char craftType=pCraft[0];
				unsigned char action=pCraft[4];

				if(action==2 && (craftType==5 || craftType==6 || craftType==7)) //airborne scout ships
				{
					unsigned short xpos=*(unsigned short *)&pLocation[2];
					unsigned short ypos=*(unsigned short *)&pLocation[4];
					//if(IsPointOnWater(xpos,ypos))
					//	continue;

					//Find over which polygon the craft is
					IsPointOnWater(xpos,ypos);
					short poly=*(short *)0x47B2D4;
					if(-1 == poly)
						continue;

					int terrainType=(*file_geodata_world_dat)[poly*20+0x10];

					unsigned short mission=*(unsigned short *)&pCraft[0x1C];
					
					*(unsigned short *)&pCraft[12]=0; //Altitude
					*(unsigned short *)&pCraft[14]=0; //Speed

					(*numAirborneShips)--;

					if(pLocation[0x10]&1)
					{
						(*numHiddenAlienShips)--;
					}

					if(mission==6) //retaliation
					{
						(*numUfosInRetaliationMission)--;
					}

					//visible
					pLocation[0x10]&=~1;
					//crash site
					pLocation[0]=5;

					//time before removing
					*(unsigned short *)&pLocation[6]=GetRandom_0_n(72)+24;
					//force visible
					*(unsigned int *)&pLocation[0x10]&=0xfffffffd;

					const char *place;

					unsigned short count=*(unsigned short *)&pLocation[0xa];
					if(count == 0)
						count=*(unsigned short *)&pLocation[0xa]=(*nextSpottedUFONumber)++;
					
					short zone=GetCountryFromPos(xpos,ypos);
					if(zone==-1)
					{
						zone=GetWorldZoneFromPos(xpos,ypos);
						if(zone==-1)
							place="Unknown";	
						else
							place=StringTable_geoscape[0x21F+zone];
					}
					else
						place=StringTable_geoscape[0x259+zone];

					const char *craft=StringTable_geoscape[0x2B1+(craftType-5)];

					if(ShowCrashInfo(craft,place,crashSite[terrainType])==1)
					{
						*geo_timeSpeed=1;
						RotateGlobeToLocation(i);
					}

					//no more than one crash at a time...
					break;
				}
			}
		}

		pLocation+=20;
	}

	UpdateAirborneShipsPosition();
}

void ModRoswell()
{
	InitRoswellStrings();
	InsertCall(0x440ECB,UpdateMovingCrafts);
}
